// 004 u_c_maze_builder_2
// 17 oct 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   John COLIBRI  http://www.jcolibri.com

(*$r+*)

unit u_c_maze_builder_2;
  interface
    uses u_c_maze_2;


    type // -- c_maze_builder: an interface for building, which
         // --   will be overridden by other descendents
         c_maze_builder= class
                           procedure build_maze; Virtual; Abstract;
                           // -- no wall
                           procedure build_room(p_room_number: Integer); Virtual; Abstract;
                           procedure build_door(p_from_room_number, p_to_room_number: Integer); Virtual; Abstract;

                           function f_c_maze: c_maze; Virtual; Abstract;
                         end; // c_maze_builder

  implementation

    begin // u_c_maze_builder
    end. // u_c_maze_builder

